﻿Shader "Hidden/Greyscale" {
    Properties {
        _MainTex ("Base (RGB)", 2D) = "white" {}
        _RenderTex ("Base (RGB)", 2D) = "black" {}
        _Greyscale ("Greyscale", Range(0, 1)) = 0
    }

    SubShader {
        Pass {
        CGPROGRAM
        #pragma vertex vert_img
        #pragma fragment frag
        #include "UnityCG.cginc"
        #pragma target 3.0

        uniform sampler2D _MainTex;
        uniform sampler2D _RenderTex;
        uniform float _Greyscale = 1.0;

        float4 frag(v2f_img i) : COLOR {
            float4 oCol = tex2D(_MainTex, i.uv);
            float4 rCol = tex2D(_RenderTex, i.uv);
            float luminance = dot(oCol.rgb, float3(0.2126729, 0.7151522, 0.0721750));
            rCol.r = clamp(rCol.r + _Greyscale, 0.0, 1.0f);
            oCol.rgb = lerp(luminance.xxx, oCol.rgb, rCol.r);
            return oCol;
        }

        ENDCG
        }
    }
}