﻿using ByteSprite.DependencyInjection;
using UnityEngine;
using UnityEngine.UI;

namespace Plants {
	public class PlantPurchaseButton : MonoBehaviour {
		[Inject]
		Cursor cursor;

		[HideInInspector]
		public Plant plant;

		void Awake () {
			Injector.Inject(this);
		}

		void Start () {
			GetComponent<Image> ().sprite = plant?.Icon;
		}

		public void SelectPlantToPlace(){
			cursor.SelectedPlant = plant;
			cursor.State = Cursor.CursorState.NewPlant;
		}

	}
}