﻿using System;
using System.Collections.Generic;

namespace ByteSprite.DependencyInjection.Container {
	public sealed class InjectionContainer : IInjectionContainer {
        readonly Dictionary<Tuple<Type, object>, object> bindings = new Dictionary<Tuple<Type, object>, object>();

        public void Bind<T>(object @object, object id = null) {
            var type = typeof(T);
            var bindingKey = Tuple.Create(type, id);

            if (!bindings.ContainsKey(bindingKey)) {
                bindings.Add(bindingKey, @object);
                return;
            }

            bindings[bindingKey] = @object;
        }

        public object GetDependency(Type type, object id = null) {
			var bindingKey = Tuple.Create(type, id);

            return !bindings.ContainsKey(bindingKey) ? null : bindings[bindingKey];
        }
	}
}