﻿using NUnit.Framework;
using ByteSprite.DependencyInjection.Container;

namespace ByteSprite.DependencyInjection.Tests {
	public class InjectionContainerTest {
		[Test]
		public void GetDependencyReturnsBoundString () {
			string dependency = "Sample Text";

			InjectionContainer container = new InjectionContainer ();
			container.Bind<string> (dependency);

			string result = (string)container.GetDependency (typeof (string));

			Assert.AreEqual (dependency, result);
		}

		[Test]
		public void GetDependencyReturnsBoundObject() {
			var dependency = new object();

			InjectionContainer container = new InjectionContainer ();
			container.Bind<object> (dependency);

			var result = container.GetDependency (typeof (object));

			Assert.AreEqual (dependency, result);
		}

		[Test]
		public void GetDependencyReturnsNullForNoBinding() {
			InjectionContainer container = new InjectionContainer();

			Assert.IsNull(container.GetDependency (typeof (int)));
		}
	}
}