﻿using System.Linq;
using Plants;
using UnityEngine;

[ExecuteInEditMode]
public class PostProcessing : MonoBehaviour {
	[SerializeField]
	RenderTexture renderTexture;
	Material material;

	void Start () {
		material = new Material (Shader.Find ("Hidden/Greyscale"));
	}

	public void OnRenderImage (RenderTexture source, RenderTexture destination) {
		material.SetTexture ("_MainTex", source);
		material.SetTexture ("_RenderTex", renderTexture);
		material.SetFloat("_Greyscale", Mathf.Clamp01(FindObjectsOfType<Plant>().Select(p => p.IsAlive).Count() / 20f));
		Graphics.Blit (source, destination, material);
	}
}