﻿using System.Linq;
using UnityEngine;

namespace Plants {
	public class InputManager : MonoBehaviour {
		ITile selected;

		public ITile Selected { get { return selected; } set {selected = value; OnSelect?.Invoke (Selected); } }
		public ITile Hovering { get; private set; }

		public event System.Action<ITile> OnSelect;

		void Update () {
			var ray = Camera.main.ScreenPointToRay (Input.mousePosition);
			var hits = Physics2D.RaycastAll (ray.origin, ray.direction);
			foreach (var hit in hits) {
				var tile = hit.collider.gameObject?.GetComponent<ITile> ();
				if (tile != null) {
					Hovering = tile;
					break;
				}
			}

			if (!hits.Any ())
				Hovering = null;

			if (Input.GetMouseButtonDown(0)) {
				Selected = Hovering;

				if (!hits.Any())
					Selected = null;
			}
		}
	}
}