﻿using UnityEngine;
using ByteSprite.DependencyInjection.Installer;

namespace Plants {
	enum DependencyId {
		None,
		GameName,
	}

	public class PlantsDependencyInjection : MonoInjectionInstaller {
		[SerializeField]
		Plant [] plants;

		[SerializeField]
		Cursor cursor;

		[SerializeField]
		PlantPurchaseButton plantPurchaseButton;

		public override void SetBindings () {
			Container.Bind<PlantPurchaseButton>(plantPurchaseButton);

			var animationManager = GetComponent<AnimationManager>();
			var inputManager = GetComponent<InputManager>();
			var plantManager = GetComponent<PlantManager>();

			Container.Bind<PlantManager>(plantManager);
			Container.Bind<Cursor> (cursor);
			Container.Bind<AnimationManager>(animationManager);
			Container.Bind<InputManager>(inputManager);

			Container.Bind<Plant[]>(plants);
		}
	}
}