﻿using UnityEngine;

namespace Plants {
	public class TileBoard {
		int Width { get; }
		int Height { get; }

		readonly ITile[,] tiles;

		public TileBoard(int width, int height){
			Width = width;
			Height = height;

			tiles = new ITile[width, height];
		}

		public void SetTile(int x, int y, ITile tile){
			if (x > Width || x < 0 || y > Height || y < 0) {
				Debug.Log($"X: {x}, Y: {y} is not on game board");
				return;
			}

			if (tiles[x, y] != null) {
				Debug.Log($"X: {x}, Y: {y} is occupied, remove it before adding a new tile here");
				return;
			}

			tiles[x, y] = tile;
		}

		public void RemoveTile(int x, int y) {
			tiles[x, y] = null;
		}

		public ITile GetTile(int x, int y) {
			return tiles[x, y];
		}
	}
}